# -*- coding: utf-8 -*-
#def unimap_all(field,camera = 'camera',higal='higal'):
import os
import shutil
import sys
from string import *
from org.python.core import PyList
from javax.swing import *
from herschel.ia.numeric import *
from herschel.ia.io.fits import *
from herschel.ia.io.fits.FitsArchive import *
from herschel.ia.dataset import *
from herschel.ia.toolbox.util import *
from herschel.ia.gui.plot import *
from herschel.pacs.cal import *
from herschel.pacs.toolboxes.all import *
from java.util import Date
from java.lang import Runtime
from herschel.ia.task import *
from java.lang import Boolean
from herschel.ia.pal import *
from herschel.ia.obs import ObservationContext
from herschel.ia.pal.query import MetaQuery
from herschel.ia.pal.pool.lstore import LocalStoreFactory
from herschel.ia.pal.browser.v2.table.model import * 
from herschel.ia.pal.util import StorageResult
from herschel.ia.pal.pool.hsa import HsaReadPool
from herschel.ia.numeric.toolbox import *
from herschel.ia.numeric.toolbox.basic import MAX
from herschel.ia.toolbox.util import SimpleFitsReaderTask
from os import sys

from herschel.spire.all import *
from herschel.spire.util import *
from herschel.ia.all import *
from herschel.ia.task.mode import *
from herschel.ia.pg import ProductSink
from java.lang import *
from java.util import *
from herschel.ia.obs.util import ObsParameter
from herschel.ia.pal.pool.lstore.util import TemporalPool
from herschel.spire.ia.pipeline.scripts.PARALLEL.PARALLEL_tasks import *
from herschel.spire.ia.pipeline.scripts.PARALLEL.PARALLEL_input import *
from herschel.spire.ia.scripts.tools.obsLoader import *

###########################SETTING INPUT
working_dir = '/data/unimap/unihipe_batch/test3'
field = ['point1','point2']

obsids_list = [[1342246768,1342246769,1342246770,1342246771],[1342246768,1342246769,1342246771]]
instrument = 'PACS'
database = 'HSA'

###########################################

n_field = len(field)
for z in range(n_field):
    exists_path =  os.path.exists(working_dir+'/'+field[z])
    if exists_path == 0:
        os.mkdir(working_dir+'/'+field[z])
    n_obsids = len(obsids_list[z])
    obsids = String1d(obsids_list[z])

        
    #########setting unimap parameter for interactive mode
    #deleted in 4.5: 'glitch_amp - positive real - glitch detection amplification near bright sources (0 = suppressed, 4 suggested)',\
    
    sys.path.append(working_dir+'/Scripts')
    
    results_list = PyList()
    dim_samples = Int1d()
    from unimap_spire import *
    from unimap_pacs import *
    
    #saving meta-data for the final header
    key = ['DATE-OBS','SPG','INSTRUME','BUNIT','WAVELNTH']
    
    comment = ['average JD','standard product generator','instrument','unit','wavelength in micron']
    
    julianDate = Double1d()
    spg_vect = String1d()
    wave_vect = String1d()
    
    for i in range(n_obsids):
        archive = HsaReadPool()
        store = ProductStorage()
        store.register(archive)
        print 'Performing meta query at the HSA for obsID:'
        print obsids[i]
        q = MetaQuery(ObservationContext,"p","p.meta['obsid'].value=='"+obsids[i]+"' and p.meta['instrument'].value=='"+instrument+"'")
        results_query = store.select(q)
        try:
            obs = results_query[0].product
        except herschel.share.io.HcssHttpGeneralSecurityException:
            JOptionPane.showMessageDialog(None, "You are not logged at the HSA or/and you are trying for accessing to proprietary data. \n Please make authentication procedure (also by using the tip reported in the README file) and start the unihipe tool again")
            sys.exit()
            #fields = [JTextField(1),JTextField(1)]
            #mylogin = JPanel()
            #mylogin.setLayout(BoxLayout(mylogin, BoxLayout.PAGE_AXIS))
            #mylogin.add(JLabel("You are not logged in at the HSA or/and you"),BoxLayout)
            #mylogin.add(JLabel("are trying accessing to proprietary data"),BoxLayout)
            #mylogin.add(JLabel(" "),BoxLayout)
            #mylogin.add(JLabel("Username"),BoxLayout)
            #mylogin.add(fields[0],BoxLayout)
            #mylogin.add(JLabel("Password"),BoxLayout)
            #mylogin.add(fields[1],BoxLayout)
            #login = JOptionPane.showConfirmDialog(None, mylogin,  "HSA login", JOptionPane.OK_CANCEL_OPTION)
            #Configuration.setProperty("hcss.ia.pal.pool.hsa.haio.apply_authentication","true") 
            #Configuration.setProperty("hcss.ia.pal.pool.hsa.haio.login_usr",fields[0].getText()) 
            #Configuration.setProperty("hcss.ia.pal.pool.hsa.haio.login_pwd",fields[1].getText())
            #obs = results_query[0].product
        startDate = obs.getMeta()['startDate'].time
        spg = obs.getMeta()['creator'].string[4:len(obs.getMeta()['creator'].string)]
###############################
        if instrument == 'SPIRE':
            results = unimap_spire(obs)                      
            dim_samples.append(results[0][0].dimensions[0])
        else:
            results = PyList()
            for w in ('blue','red'):
                frames = PacsContext(obs.level1).averaged.getCamera(w).product.selectAll()
                if w == 'blue':
                    blue = frames.getMeta()['blue'].string
                    if blue == 'blue1':
                        wave = '70'
                    else:
                        wave = '100'
                    wave_vect.append(wave)                
                calTree = getCalTree()
###############################                
                if w == 'blue':
                    bol = 2048
                    pix_size = 3.2
                    n_row = 32
                else:
                    bol = 512
                    pix_size = 6.4
                    n_row = 16
                scanning_flag = Int1d(frames.dimensions[2])
            ######Select the telescope scanning    
                start_ind = frames['BlockTable']['StartIdx'].data
                end_ind = frames['BlockTable']['EndIdx'].data
                id = frames['BlockTable']['Id'].data
                start_scan = start_ind.where(id == "PHOT_SCANMODE").toInt1d()
                end_scan = end_ind.where(id == "PHOT_SCANMODE").toInt1d()
                is_scan = Range(start_ind[start_scan[0]], end_ind[end_scan[0]])
                scanning_flag[is_scan] = 1
                index = 2
                for i in range(len(start_scan)-1):
                    is_scan = Range(start_ind[start_scan[i+1]], end_ind[end_scan[i+1]])
                    scanning_flag[is_scan] = index
                    index = index + 1
            
                if (frames.containsKey("Ra") == False): frames = photAssignRaDec(frames, calTree=calTree)
            ####################################### 
                px = (pix_size / 3600.)**2
                sr = 57.2957795131**2
                f = (sr/px) * 1e-6
                signal = (frames['Signal'].data * f)
                ra = frames['Ra'].data
                dec = frames['Dec'].data
                sat = frames.getMask("SATURATION")
                bad = frames.getMask("BADPIXELS")[:,:,0]
            
                s = Float2d() #signal
                r = Float2d()
                d = Float2d()
                f = Int2d()
                gb = Int1d()
                index = 1
                for i_column in range(signal.dimensions[1]):
                    print 'PACS frames: column', i_column
                    for i_row in range(signal.dimensions[0]):
                         if bad[i_row,i_column] == False:
                             gb.append(index)
                             pixel_I = Float1d(signal[i_row,i_column,:])
                             s.append(pixel_I,1)
                             pixel_Ra = Float1d(ra[i_row,i_column,:])
                             r.append(pixel_Ra,1)
                             pixel_Dec = Float1d(dec[i_row,i_column,:])
                             d.append(pixel_Dec,1)
                             ind = sat[i_row,i_column,:].where(sat[i_row,i_column,:] == True)
                             pixel_Flag = Int1d(signal.dimensions[2])
                             pixel_Flag[ind] = 1
                             f.append(pixel_Flag,1)
                         else:
                             print 'PACS frames: pixel', i_column, i_row, 'is a bad detector!!'
                         index = index + 1
            
                sample = Int1d(len(gb))
                sample[:] = signal.dimensions[2]
                results.append([s,r,d,f,gb,Int1d().append(bol),Int1d().append(scanning_flag), sample])
                
                del s,r,d,f,gb
                System.gc()
                
        #computing JD    
        date = str(startDate)[0:10]
        time = str(startDate)[11:19]   
        date=date.split("-")
        dd=int(date[2])
        mm=int(date[1])
        yyyy=int(date[0])
        time=time.split(":")
        hh=float(time[0])
        min=float(time[1]) 
        sec=float(time[2])
        UT=hh+min/60+sec/3600
        if (100*yyyy+mm-190002.5)>0:
            sig=1
        else:
            sig=-1
        JD = 367*yyyy - int(7*(yyyy+int((mm+9)/12))/4) + int(275*mm/9) + dd + 1721013.5 + UT/24 - 0.5*sig +0.5
        julianDate.append(JD)
        
        spg_vect.append(spg)
        
        results_list.append(results)
        del results
        System.gc()
    
    JD_avg = str(MEAN(julianDate))
    print spg_vect
    ind = spg_vect.where(spg_vect == spg_vect[0])
    if (len(ind.toInt1d()) != n_obsids):
        print 'WARNING!! you are combinining observations with different SPG! EXIT'
        sys.exit()
    #meta_value = String1d([JD_avg,spg,instrument,'MJy/sr'])
    
    if instrument == 'SPIRE':
        camera=['PSW','PMW','PLW']
        waves = ['250','350','500']
        for jspire in range(3):
            exists_path =  os.path.exists(working_dir+'/'+field[z]+'/'+camera[jspire])
            if exists_path == 0:
                os.mkdir(working_dir+'/'+field[z]+'/'+camera[jspire])
            #n_bolo = results[0][jspire].dimensions[1]
            for i in range(n_obsids):
                s = results_list[i][0][jspire].copy()
                r = results_list[i][1][jspire].copy()
                d = results_list[i][2][jspire].copy()
                f = results_list[i][3][jspire].copy()
                gb = results_list[i][4][jspire].copy()
                sc = results_list[i][6][jspire].copy()
                sp = results_list[i][7][jspire].copy()
                print 'Saving SPIRE '+camera[jspire]+' outputs'
                array = [s,r,d,f,gb,Int1d().append(results_list[0][5][jspire]),sc,sp]
                description = ['Signal','Ra','Dec','Flag','Good bolometers','Number bolometers'\
                ,'Scanning flag ', 'Number of samples']
                c=CompositeDataset()
                for j in range(len(array)):
                    dataset = ArrayDataset(description=description[j])
                    dataset.data = array[j]
                    c[description[j]] = dataset
                p = Product(description='Unimap input')
                p[obsids[i]] = c
                fits = FitsArchive(reader=STANDARD_READER)
                fits.save(working_dir+'/'+field[z]+'/'+camera[jspire]+'/unimap_obsid_'+field[z]+'_'+camera[jspire]+'_'+obsids[i]+'.fits',p)
                del array,p
                System.gc()
            m = TableDataset()
            meta_value = String1d([JD_avg,spg,instrument,'MJy/sr',waves[jspire]])
            #meta_value.append(waves[jspire])
            m['meta'] = Column(meta_value)
            meta_name = working_dir+'/'+field[z]+'/'+camera[jspire]+'/unimap_meta_'+camera[jspire]+'.dat'
            #meta_name = path_source+meta_root+'_'+camera[jspire]'.dat'
            asciiTableWriter(m,meta_name,formatterHeader=False)
                
    else:
        print wave_vect
        ind = wave_vect.where(wave_vect == wave_vect[0])
        if (len(ind.toInt1d()) != n_obsids):
            print 'WARNING!! you are mixing blue and green observations!'
        #   sys.exit() !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
        #n_bolo = results[0].dimensions[1]
        
        for t in (0,1):
            if t ==1:
                camera = 'red'
                wave = '160'
            ii = 0
            for i in range(n_obsids):
                if t ==0:
                    if wave_vect[ii] == '70': camera = 'blue'
                    if wave_vect[ii] == '100': camera = 'green'
                    ii = ii+1
                exists_path =  os.path.exists(working_dir+'/'+field[z]+'/'+camera)
                if exists_path == 0:
                    os.mkdir(working_dir+'/'+field[z]+'/'+camera)
                s = results_list[i][t][0].copy()
                r = results_list[i][t][1].copy()
                d = results_list[i][t][2].copy()
                f = results_list[i][t][3].copy()
                gb = results_list[i][t][4].copy()
                sc = results_list[i][t][6].copy()
                sp = results_list[i][t][7].copy()    
                print 'Saving PACS '+camera+' outputs'
                array = [s,r,d,f,gb,results_list[i][0][5],sc,sp]
                description = ['Signal','Ra','Dec','Flag','Good bolometers','Number bolometers'\
                ,'Scanning flag ', 'Number of samples']
                c=CompositeDataset()
                for j in range(len(array)):
                    dataset = ArrayDataset(description=description[j])
                    dataset.data = array[j]
                    c[description[j]] = dataset
                p = Product(description='Unimap input')
                p[obsids[i]] = c
                fits = FitsArchive(reader=STANDARD_READER)
                fits.save(working_dir+'/'+field[z]+'/'+camera+'/unimap_obsid_'+field[z]+'_'+camera+'_'+obsids[i]+'.fits',p)
                del array,p
                System.gc()
                m = TableDataset()
                meta_value = String1d([JD_avg,spg,instrument,'MJy/sr',wave])
            #meta_value.append(wave)
                m['meta'] = Column(meta_value)
            meta_name = working_dir+'/'+field[z]+'/'+camera+'/unimap_meta_'+camera+'.dat'
            asciiTableWriter(m,meta_name,formatterHeader=False)
