# -*- coding: utf-8 -*-
#    import os
#    import shutil
#    import sys
#    from string import *
#    from org.python.core import PyList
#    from javax.swing import *
#    from herschel.ia.numeric import *
#    from herschel.ia.io.fits import *
#    from herschel.ia.io.fits.FitsArchive import *
#    from herschel.ia.dataset import TableDataset	
#    from herschel.ia.toolbox.util import *
#    from herschel.ia.task import *
#    from java.lang import *
#    from herschel.ia.pal import *
#    from herschel.ia.obs import ObservationContext
#    from herschel.ia.pal.query import MetaQuery
#    from herschel.ia.pal.pool.lstore import LocalStoreFactory
#    from herschel.ia.pal.browser.v2.table.model import * 
#    from herschel.ia.pal.util import StorageResult
#    from herschel.ia.pal.pool.hsa import HsaReadPool
#    from herschel.ia.numeric.toolbox.basic import *
#    from convert_binary import convert_binary
def unimap_spire(obs,path=''):
    import os
    from string import split
    from org.python.core import PyList
    from herschel.ia.numeric import String1d
    from herschel.ia.numeric import Int1d
    from herschel.ia.numeric import Int2d
    from herschel.ia.numeric import Float1d
    from herschel.ia.numeric import Float2d
    from herschel.ia.numeric import Double1d
    from herschel.ia.numeric import Double2d
    from herschel.ia.dataset import TableDataset
    from convert_binary import convert_binary
    from herschel.ia.numeric.toolbox.basic import Reverse
    from herschel.ia.toolbox.util import SimpleFitsReaderTask
    
    camera=['PSW','PMW','PLW']
    bol=[144,93,48]
    mask=TableDataset()
    signal=TableDataset()
    ra=TableDataset()
    dec=TableDataset()
    scanning_flag=Int1d()
    star_f=0
    read = SimpleFitsReaderTask()
    
    if (path != ''):
        list = os.listdir(path) 
        nlines = len(list)
        scanle= Int1d(nlines)
        scanlinenum = Int1d(nlines)
        levels_1 = []
        for l in range(nlines):
            lev1 = read(path+'/'+list[l])
            levels_1.append(lev1)
            scanlinenum[l]= lev1.meta['scanLineNum'].long
        for i in range(nlines):
            ii = scanlinenum.where(scanlinenum == i).toInt1d()
            lev1 = levels_1[ii[0]]
            len_scan=lev1['mask'].getRowCount()
            flag_prov=Int1d(len_scan)
            flag_prov[:]=i+1

            if (i == 0):
                col_name_sig=lev1['mask'].getColumnNames()
                col_name_coor=lev1['ra'].getColumnNames()
                len_name=len(col_name_sig)
                column_name=String1d()
                column_name_coor=String1d()
                for i_name in range(len_name):
                    column_name.append(col_name_sig[i_name])
                    column_name_coor.append(col_name_coor[i_name])

            mask.concatenate(lev1['mask'])
            signal.concatenate(lev1['signal'])
            ra.concatenate(lev1['ra'])
            dec.concatenate(lev1['dec'])
            scanning_flag.append(flag_prov)
#HSA data
    else:
        lev1 = obs.level1
        for i in range(lev1.getCount()):
            if (i == 0):
                col_name_sig=lev1.refs[i].product["mask"].getColumnNames()
                col_name_coor=lev1.refs[i].product["ra"].getColumnNames()
                len_name=len(col_name_sig)
                column_name=String1d()
                column_name_coor=String1d()
                for i_name in range(len_name):
                    column_name.append(col_name_sig[i_name])
                    column_name_coor.append(col_name_coor[i_name])
            len_scan=lev1.refs[i].product["mask"].getRowCount()
            flag_prov=Int1d(len_scan)
            flag_prov[:]=i+1
            mask.concatenate(lev1.refs[i].product["mask"])
            signal.concatenate(lev1.refs[i].product["signal"])
            ra.concatenate(lev1.refs[i].product["ra"])
            dec.concatenate(lev1.refs[i].product["dec"])
            scanning_flag.append(flag_prov)
        
    nsample=len(mask[0].data)
    n_bolo_tot=len(column_name)
    s_psw = Double2d() #signal
    r_psw = Float2d()
    d_psw = Float2d()
    f_psw = Int2d()
    gb_psw = Int1d()
    s_pmw = Double2d() #signal
    r_pmw = Float2d()
    d_pmw = Float2d()
    f_pmw = Int2d()
    gb_pmw = Int1d()
    s_plw = Double2d() #signal
    r_plw = Float2d()
    d_plw = Float2d()
    f_plw = Int2d()
    gb_plw = Int1d()
    termistor=['R1','T1','T2','DP1','DP2']
    index_psw=0
    index_pmw=0
    index_plw=0
    js_gb=0
    jm_gb=0
    jl_gb=0
    for j in range (1,n_bolo_tot):
        ind_term=0
        ind_dead=0
        tot_flag=0
        #        print 'make '+j.toString()+' bolometer:',column_name[j]
        names=split(column_name[j],'W')
        if names[0] == 'PS':
        #            print 'it is a PSW bolometer'
            js_gb=js_gb+1
            for k in range (len(termistor)):
                if names[1] == termistor[k]:
                    print column_name[j],' is a termistor'
                    ind_term=1 
            if ind_term == 0:
                flag=mask[j].data
                first_flag=flag[0]
                first_bin=convert_binary(first_flag)
                first_bin.reverse()
                if (first_bin[0] == 1 or first_bin[1] == 1 or first_bin[2] == 1 or first_bin[7] == 1 or first_bin[15] == 1):
                    print column_name[j],' is dead'
                    ind_dead=1
                else:
                    flag_prov=Int1d(len(flag))
                    flag_prov[:]=0
                    for in_flag in range(len(flag)):
                        if flag[in_flag] != 0:
                            flag_bin=convert_binary(flag[in_flag])
                            flag_bin.reverse()
                            if (flag_bin[3] == 1 or flag_bin[4] == 1 or flag_bin[2] == 1 or flag_bin[15] == 1 or flag_bin[1] == 1 or flag_bin[7] == 1 or flag_bin[0] == 1):
                                flag_prov[in_flag]=1
                                tot_flag=tot_flag+1
                    perc=(float(tot_flag)/float(len(flag)))*100.
                    if perc >= 90.:
                        ind_dead=1
                        print column_name[j],' is too flagged'
                if ind_dead == 0:
                    car=column_name_coor.where(column_name_coor == column_name[j])
                    sel_ind=car.toInt1d()
                    #     print ra[sel_ind[0]].data[0:10],mask[j].data[0:10],column_name[j]
                    s_psw.append(Double1d(signal[j].data),1)
                    f_psw.append(flag_prov,1)
                    r_psw.append(Float1d(ra[sel_ind[0]].data),1)
                    d_psw.append(Float1d(dec[sel_ind[0]].data),1)
                    gb_psw.append(js_gb)
                    index_psw=index_psw+1
        else:
            if names[0] == 'PM':
                #     print 'it is a PMW bolometer'
                jm_gb=jm_gb+1
                for k in range (len(termistor)):
                    if names[1] == termistor[k]:
                        print column_name[j],' is a termistor'
                        ind_term=1
                if ind_term == 0:
                    flag=mask[j].data
                    first_flag=flag[0]
                    first_bin=convert_binary(first_flag)
                    first_bin.reverse()
                    if (first_bin[0] == 1 or first_bin[1] == 1 or first_bin[2] == 1 or first_bin[7] == 1 or first_bin[15] == 1):
                        print column_name[j],' is dead'
                        ind_dead=1
                    else:
                        flag_prov=Int1d(len(flag))
                        flag_prov[:]=0
                        for in_flag in range(len(flag)):
                            if flag[in_flag] != 0:
                                flag_bin=convert_binary(flag[in_flag])
                                flag_bin.reverse()
                                if (flag_bin[3] == 1 or flag_bin[4] == 1 or flag_bin[2] == 1 or flag_bin[15] == 1 or flag_bin[1] == 1 or flag_bin[7] == 1 or flag_bin[0] == 1):
                                    flag_prov[in_flag]=1
                                    tot_flag=tot_flag+1
                        perc=(float(tot_flag)/float(len(flag)))*100.
                        if perc >= 90.:
                            ind_dead=1
                            print column_name[j],' is too flagged'    
                    if ind_dead == 0:
                        car=column_name_coor.where(column_name_coor == column_name[j])
                        sel_ind=car.toInt1d()
                        #          print ra[sel_ind[0]].data[0:10],mask[j].data[0:10],column_name[j]
                        s_pmw.append(Double1d(signal[j].data),1)
                        f_pmw.append(flag_prov,1)
                        r_pmw.append(Float1d(ra[sel_ind[0]].data),1)
                        d_pmw.append(Float1d(dec[sel_ind[0]].data),1)
                        gb_pmw.append(jm_gb)
                        index_pmw=index_pmw+1
            else:
                if names[0] == 'PL':
                    #   print 'it is a PLW bolometer'
                    jl_gb=jl_gb+1
                    for k in range (len(termistor)):
                        if names[1] == termistor[k]:
                            print column_name[j],' is a termistor'
                            ind_term=1
                    if ind_term == 0:
                        flag=mask[j].data
                        first_flag=flag[0]
                        first_bin=convert_binary(first_flag)
                        first_bin.reverse()
                        if (first_bin[0] == 1 or first_bin[1] == 1 or first_bin[2] == 1 or first_bin[7] == 1 or first_bin[15] == 1):
                            print column_name[j],' is dead'
                            ind_dead=1     
                        else:
                            flag_prov=Int1d(len(flag))
                            flag_prov[:]=0
                            for in_flag in range(len(flag)):
                                if flag[in_flag] != 0:
                                    flag_bin=convert_binary(flag[in_flag])
                                    flag_bin.reverse()
                                    if (flag_bin[3] == 1 or flag_bin[4] == 1 or flag_bin[2] == 1 or flag_bin[15] == 1 or flag_bin[1] == 1 or flag_bin[7] == 1 or flag_bin[0] == 1):
                                        flag_prov[in_flag]=1
                                        tot_flag=tot_flag+1
                            perc=(float(tot_flag)/float(len(flag)))*100.
                            if perc >= 90.:
                                ind_dead=1
                                print column_name[j],' is too flagged'
                        if ind_dead == 0:
                            car=column_name_coor.where(column_name_coor == column_name[j])
                            sel_ind=car.toInt1d()
                            #         print ra[sel_ind[0]].data[0:10],mask[j].data[0:10],column_name[j]
                            s_plw.append(Double1d(signal[j].data),1)
                            f_plw.append(flag_prov,1)
                            r_plw.append(Float1d(ra[sel_ind[0]].data),1)
                            d_plw.append(Float1d(dec[sel_ind[0]].data),1)
                            gb_plw.append(jl_gb)
                            index_plw=index_plw+1
    
    sample_psw = Int1d(len(gb_psw))
    sample_psw[:] = nsample
    sample_pmw = Int1d(len(gb_pmw))
    sample_pmw[:] = nsample
    sample_plw = Int1d(len(gb_plw))
    sample_plw[:] = nsample
####################################### 
    s=[s_psw,s_pmw,s_plw]
    r=[r_psw,r_pmw,r_plw]
    d=[d_psw,d_pmw,d_plw]
    f=[f_psw,f_pmw,f_plw]
    gb=[gb_psw,gb_pmw,gb_plw]
    scan_flag=[scanning_flag,scanning_flag,scanning_flag]
    sample = [sample_psw,sample_pmw,sample_plw]
    bolo=Int1d()
    for jj in range(3):
        bolo.append(bol[jj])
    return s,r,d,f,gb,Int1d().append(bolo),scan_flag,sample
